<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006~2019 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: liu21st <liu21st@gmail.com>
// +----------------------------------------------------------------------
declare (strict_types = 1);

namespace app\admin;

use think\App;
use think\exception\ValidateException;
use think\Validate;

use think\facade\Session;

/**
 * 控制器基础类
 */
abstract class BaseController
{
    /**
     * Request实例
     * @var \think\Request
     */
    protected $request;

    /**
     * 应用实例
     * @var \think\App
     */
    protected $app;

    /**
     * 是否批量验证
     * @var bool
     */
    protected $batchValidate = false;

    /**
     * 控制器中间件
     * @var array
     */
    protected $middleware = [];
	
	/**
	 * 控制器中间件
	 * @var array
	 */
	protected $access_admin = [];

    /**
     * 构造方法
     * @access public
     * @param  App  $app  应用对象
     */
    public function __construct(App $app)
    {
        $this->app     = $app;
        $this->request = $this->app->request;
				
				
        // 控制器初始化
        $this->initialize();
    }

    // 初始化
    protected function initialize()
    {
		// 验证登陆信息
		$access_admin = Session::has('access_admin');
		if ( $access_admin ) {
			
		}else{
			echo '<script language="javascript" type="text/javascript"> top.location.href="/admin.php/login/index"; </script>';
			exit(json_encode(array(
				'code' 	=> 1001,
				'msg'	=> "You do not have permission to access."
			)));
		}
	}

    /**
     * 验证数据
     * @access protected
     * @param  array        $data     数据
     * @param  string|array $validate 验证器名或者验证规则数组
     * @param  array        $message  提示信息
     * @param  bool         $batch    是否批量验证
     * @return array|string|true
     * @throws ValidateException
     */
    protected function validate(array $data, $validate, array $message = [], bool $batch = false)
    {
        if (is_array($validate)) {
            $v = new Validate();
            $v->rule($validate);
        } else {
            if (strpos($validate, '.')) {
                // 支持场景
                list($validate, $scene) = explode('.', $validate);
            }
            $class = false !== strpos($validate, '\\') ? $validate : $this->app->parseClass('validate', $validate);
            $v     = new $class();
            if (!empty($scene)) {
                $v->scene($scene);
            }
        }

        $v->message($message);

        // 是否批量验证
        if ($batch || $this->batchValidate) {
            $v->batch(true);
        }

        return $v->failException(true)->check($data);
    }

    protected function dealEqualInput($result ,$equal_array)
    {
        foreach ($equal_array as $k => $v) {
            $value = input($v);
            if (!empty($value)) {
                $result[] = [is_numeric($k) ? $v : $k,'=',$value];
            }
        }

        return $result;
    }

    protected function dealLikeInput($result,$like_array)
    {
        foreach ($like_array as $k => $v) {
            $value = input($v);
            if (!empty($value)) {
                $result[] = [is_numeric($k) ? $v : $k,'like',"%{$value}%"];
            }
        }

        return $result;
    }
}
